# generated from rosidl_generator_py/resource/_idl.py.em
# with input from system_modes_msgs:msg/ModeEvent.idl
# generated code does not contain a copyright notice

# This is being done at the module level and not on the instance level to avoid looking
# for the same variable multiple times on each instance. This variable is not supposed to
# change during runtime so it makes sense to only look for it once.
from os import getenv

ros_python_check_fields = getenv('ROS_PYTHON_CHECK_FIELDS', default='')


# Import statements for member types

import builtins  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_ModeEvent(type):
    """Metaclass of message 'ModeEvent'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('system_modes_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'system_modes_msgs.msg.ModeEvent')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg__mode_event
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg__mode_event
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg__mode_event
            cls._TYPE_SUPPORT = module.type_support_msg__msg__mode_event
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg__mode_event

            from system_modes_msgs.msg import Mode
            if Mode.__class__._TYPE_SUPPORT is None:
                Mode.__class__.__import_type_support__()

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
        }


class ModeEvent(metaclass=Metaclass_ModeEvent):
    """Message class 'ModeEvent'."""

    __slots__ = [
        '_timestamp',
        '_start_mode',
        '_goal_mode',
        '_check_fields',
    ]

    _fields_and_field_types = {
        'timestamp': 'uint64',
        'start_mode': 'system_modes_msgs/Mode',
        'goal_mode': 'system_modes_msgs/Mode',
    }

    # This attribute is used to store an rosidl_parser.definition variable
    # related to the data type of each of the components the message.
    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('uint64'),  # noqa: E501
        rosidl_parser.definition.NamespacedType(['system_modes_msgs', 'msg'], 'Mode'),  # noqa: E501
        rosidl_parser.definition.NamespacedType(['system_modes_msgs', 'msg'], 'Mode'),  # noqa: E501
    )

    def __init__(self, **kwargs):
        if 'check_fields' in kwargs:
            self._check_fields = kwargs['check_fields']
        else:
            self._check_fields = ros_python_check_fields == '1'
        if self._check_fields:
            assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
                'Invalid arguments passed to constructor: %s' % \
                ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.timestamp = kwargs.get('timestamp', int())
        from system_modes_msgs.msg import Mode
        self.start_mode = kwargs.get('start_mode', Mode())
        from system_modes_msgs.msg import Mode
        self.goal_mode = kwargs.get('goal_mode', Mode())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.get_fields_and_field_types().keys(), self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    if self._check_fields:
                        assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.timestamp != other.timestamp:
            return False
        if self.start_mode != other.start_mode:
            return False
        if self.goal_mode != other.goal_mode:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def timestamp(self):
        """Message field 'timestamp'."""
        return self._timestamp

    @timestamp.setter
    def timestamp(self, value):
        if self._check_fields:
            assert \
                isinstance(value, int), \
                "The 'timestamp' field must be of type 'int'"
            assert value >= 0 and value < 18446744073709551616, \
                "The 'timestamp' field must be an unsigned integer in [0, 18446744073709551615]"
        self._timestamp = value

    @builtins.property
    def start_mode(self):
        """Message field 'start_mode'."""
        return self._start_mode

    @start_mode.setter
    def start_mode(self, value):
        if self._check_fields:
            from system_modes_msgs.msg import Mode
            assert \
                isinstance(value, Mode), \
                "The 'start_mode' field must be a sub message of type 'Mode'"
        self._start_mode = value

    @builtins.property
    def goal_mode(self):
        """Message field 'goal_mode'."""
        return self._goal_mode

    @goal_mode.setter
    def goal_mode(self, value):
        if self._check_fields:
            from system_modes_msgs.msg import Mode
            assert \
                isinstance(value, Mode), \
                "The 'goal_mode' field must be a sub message of type 'Mode'"
        self._goal_mode = value
